Rem --- eWON start section: Cyclic Section
eWON_cyclic_section:
Rem --- eWON user (start)
Rem --- eWON user (end)
End
Rem --- eWON end section: Cyclic Section
Rem --- eWON start section: Init Section
eWON_init_section:
Rem --- eWON user (start)
//Recupero Identificativo nome eWON
SETSYS SYS, "LOAD"
idn$=GETSYS SYS, "Identification"
@NomeEwon
//Inizializzazione variabili
msg$=""
//Lancio routine MQTT alla connessione VPN
ONVPN '@WANAction(GETSYS PRG, "EVTINFO")'
//Lancio routine MQTT all'attivazione dello script
@Start()
//Invio di tutti gli stati su richiesta dell'utente
ONCHANGE "invia_val","GOTO InvioVal"
Rem --- eWON user (end)
End
Rem --- eWON end section: Init Section
Rem --- eWON start section: Update MQTT
Rem --- eWON user (start)
// Stato WAN
FUNCTION WANAction($WANStatus%)
IF $WANStatus% = 1 Then
  PRINT "WAN up"
  @Start()
ELSE
  MQTT "close"
  PRINT "WAN down"
ENDIF
ENDFN
// Start comunicazione
FUNCTION Start()
PRINT "starting MQTT"
@cloudMqttInit()
@cloudMqttConnect()
ENDFN
// Inizializzazione MQTT
Function cloudMqttInit()
MQTT "close"
Mqtt "Open",idn$,"5.189.128.2"
Mqtt "SetParam","Port","1883"
Mqtt "SetParam","UserName","root"
Mqtt "SetParam","Password","1234"
MQTT "subscribe", "MQTT_eWON/"+"MQTT_"+idn$+"/cmd", 0
//@cloudMqttConnect()
ENDFN
// Connessione/stato MQTT
FUNCTION cloudMqttConnect()
PRINT "cloudMqttConnect()"
MQTT "connect"
ONMQTT '@readMsg(MQTT("read"))'
ONMQTTSTATUS '@cloudMqttMQTTStatusChange(MQTT("status"))'
ENDFN
// Stream messaggio MQTT
Function readMsg($msgID%)
IF $msgID% > 0 THEN
PRINT "readMsg"
msgTopic$ = MQTT "msgtopic"
msgData$ = MQTT "msgdata"
//PRINT "received: "; msgTopic$; " -> "; msgData$
//Parse messaggio MQTT ricevuto
endStr% = INSTR 1, msgData$, "}"
IF (endStr% > 0) THEN
   PRINT "cmd: " + msgData$
   initStr1% = INSTR 1, msgData$, "{"+CHR$(34)
   initStr2% = INSTR 1, msgData$, CHR$(34)+":"
     IF (initStr1% > 0) AND (initStr2% > 0) THEN
        varName$ = msgData$((initStr1%+2) TO (initStr2%-1))
        varValue$ = msgData$((initStr2%+2) TO (endStr%-1))
     ENDIF
           IF varName$="Telefono_1" THEN
             Telefono_1@=VAL varValue$
           ENDIF 
           IF varName$="Telefono_2" THEN
             Telefono_2@=VAL varValue$
           ENDIF
           IF varName$="Telefono_3" THEN
           Telefono_3@=VAL varValue$
         ENDIF 
         
           IF varName$="Telefono_4" THEN
          Telefono_4@=VAL varValue$
         ENDIF
      
           IF varName$="Telefono_5" THEN
           Telefono_5@=VAL varValue$
         ENDIF
      
           IF varName$="Telefono_6" THEN
           Telefono_6@=VAL varValue$
         ENDIF
        
           IF varName$="Isteresi_regolazione_portata" THEN
           Isteresi_regolazione_portata@=VAL varValue$
         ENDIF
                 
           IF varName$="Isteresi_regolazione_pressione" THEN
           Isteresi_regolazione_pressione@=VAL varValue$
         ENDIF
                  
           IF varName$="SP_allarme_press_ingresso_min" THEN
           SP_allarme_press_ingresso_min@=VAL varValue$
         ENDIF
                  
           IF varName$="SP_allarme_press_uscita_min" THEN
           SP_allarme_press_uscita_min@=VAL varValue$
         ENDIF
                  
           IF varName$="SP_allarme_press_uscita_max" THEN
           SP_allarme_press_uscita_max@=VAL varValue$
         ENDIF
                  
           IF varName$="SP_regolazione_portata" THEN
           SP_regolazione_portata@=VAL varValue$
         ENDIF
                  
           IF varName$="SP_allarme_portata_uscita_massima" THEN
           SP_allarme_portata_uscita_massima@=VAL varValue$
         ENDIF
                  
           IF varName$="SP_regolazione_pressione" THEN
           SP_regolazione_pressione@=VAL varValue$
         ENDIF
                  
           IF varName$="Lunedi" THEN
           Lunedi@=VAL varValue$
         ENDIF
                  
           IF varName$="Martedi" THEN
           Martedi@=VAL varValue$
         ENDIF
                  
           IF varName$="Mercoledi" THEN
           Mercoledi@=VAL varValue$
         ENDIF
                  
           IF varName$="Giovedi" THEN
           Giovedi@=VAL varValue$
         ENDIF
         
          IF varName$="Venerdi" THEN
           Venerdi@=VAL varValue$
         ENDIF
         
          IF varName$="Sabato" THEN
           Sabato@=VAL varValue$
         ENDIF
         
          IF varName$="Domenica" THEN
           Domenica@=VAL varValue$
         ENDIF
                                      
         IF varName$="chiudi" THEN
             IF varValue$="True" THEN
             SETIO "Cmd_chiudi_valvola", 1
             ELSE
             SETIO "Cmd_chiudi_valvola", 0
             ENDIF
         ENDIF
         
         IF varName$="apri" THEN
             IF varValue$="True" THEN
             SETIO "Cmd_apri_valvola", 1
             ELSE
             SETIO "Cmd_apri_valvola", 0
             ENDIF
         ENDIF
         
            IF varName$="chiudi_sicur" THEN
             IF varValue$="True" THEN
             //SETIO "cmd_chiusa_di_sicurezza", 1
             SETIO "chiudi_sicur",1
             ELSE
             //SETIO "cmd_chiusa_di_sicurezza", 0
             SETIO "chiudi_sicur",0
             ENDIF
         ENDIF
         
            IF varName$="reset_max" THEN
             IF varValue$="True" THEN
             SETIO "PLS_reset_allarme_press_max", 1
             ELSE
             SETIO "PLS_reset_allarme_press_max", 0
             ENDIF
         ENDIF
         
          IF varName$="forza_funz" THEN
             IF varValue$="True" THEN
             //SETIO "cmd_forza_funzione", 1
             SETIO "forza_funz", 1
             ELSE
             //SETIO "cmd_forza_funzione", 0
             SETIO "forza_funz", 0
             ENDIF
         ENDIF
         
          IF varName$="Reset" THEN
             IF varValue$="True" THEN
             SETIO "Reset_plc", 1
             ELSE
             SETIO "Reset_plc", 0
             ENDIF
         ENDIF
         
         IF varName$="invia_val" THEN
             IF varValue$="True" THEN
             SETIO "invia_val", 1
             ELSE
             SETIO "invia_val", 0
             ENDIF
         ENDIF
ENDIF
// Verifica nuovo messaggio
@readMsg(Mqtt("read"))
ENDIF
ENDFN
FUNCTION cloudMqttMQTTStatusChange($status%)
PRINT "cloudMqttMQTTStatusChange"
IF $status% = 5 Then
  PRINT "MQTT connected"
  //Invio di tutti i cmd
  @cloudMQTTPublishAllCmd()
  //Invio di tutti gli stati
  @cloudMQTTPublishAllSts()
  //Invio degli stati al cambio di uno di questi
  ONCHANGE "chiudi_sicur","@cloudMQTTPublish('chiudi_sicur')"
  ONCHANGE "forza_funz","@cloudMQTTPublish('forza_funz')"
  ONCHANGE "apri","@cloudMQTTPublish('apri')"
  ONCHANGE "chiudi","@cloudMQTTPublish('chiudi')"
  ONCHANGE "Stato_funzione","@cloudMQTTPublish('Stato_funzione')"
  ONCHANGE "Allarme_batterie","@cloudMQTTPublish('Allarme_batterie')"
  ONCHANGE "Pressione_in_ingresso","@cloudMQTTPublish('Pressione_in_ingresso')"
  ONCHANGE "Pressione_in_uscita","@cloudMQTTPublish('Pressione_in_uscita')"
  ONCHANGE "Contabilizzatore","@cloudMQTTPublish('Contabilizzatore')"
  ONCHANGE "Portata_istantanea","@cloudMQTTPublish('Portata_istantanea')"
  ONCHANGE "Stato_elettrovalvola","@cloudMQTTPublish('Stato_elettrovalvola')"
  //Invio allarmi quando si attivano
  ONCHANGE "Allarme_pannello_solare","@cloudMQTTPublish('Allarme_pannello_solare')"
  ONCHANGE "Allarme_apertura_quadro","@cloudMQTTPublish('Allarme_apertura_quadro')"
  ONCHANGE "Allarme_pressione_uscita","@cloudMQTTPublish('Allarme_pressione_uscita')"
  ONCHANGE "Allarme_portata_uscita_max","@cloudMQTTPublish('Allarme_portata_uscita_max')"
  ONCHANGE "Allarme_portata_residua_EV_chiusa","@cloudMQTTPublish('Allarme_portata_residua_EV_chiusa')"
  ONCHANGE "Stato_selettore","@cloudMQTTPublish('Stato_selettore')"
  ONCHANGE "Allarme_guasto_pressostato", "@cloudMQTTPublish('Allarme_guasto_pressostato')"
  ONCHANGE "Allarme_pressione_non_raggiungibile", "@cloudMQTTPublish('Allarme_pressione_non_raggiungibile')"
ELSE
  PRINT "MQTT disconnected"
ENDIF
ENDFN
// Publish MQTT
Function cloudMQTTPublish($NomeValore$)
PRINT "cloudMQTTPublish"
statoMqtt% = MQTT "status"
IF statoMqtt% = 5 THEN
  value = GETIO $NomeValore$
  IF ($NomeValore$<>"chiudi_sicur" AND $NomeValore$<>"forza_funz") THEN//IF ($NomeValore$<>"apri" AND $NomeValore$<>"chiudi") THEN
    msg$= "{"+CHR$(34)+$NomeValore$+CHR$(34)+":"+STR$ value+"}"
  ELSE
    IF ($NomeValore$="chiudi_sicur") THEN//IF ($NomeValore$="apri") THEN
      msg$= "{"+CHR$(34)+"bottone_1"+CHR$(34)+":"+STR$ value+"}"
    ELSE
      msg$= "{"+CHR$(34)+"bottone_2"+CHR$(34)+":"+STR$ value+"}"
    ENDIF
  ENDIF
ENDIF
PRINT "sts: " + msg$
topicSts$="MQTT_eWON/"+"MQTT_"+idn$+"/sts"
MQTT "Publish",topicSts$,msg$,0,0
msg$=""
//SMS Allarmi
IF ($NomeValore$="Allarme_apertura_quadro") THEN @SMSAllarmi
IF ($NomeValore$="Allarme_pressione_uscita") THEN @SMSAllarmi
ENDFN
FUNCTION cloudMQTTPublishAllSts()
msg$= "{"+CHR$(34)+"Stato_valvola_sfioro"+CHR$(34)+":"+STR$ Stato_valvola_sfioro@+","+CHR$(34)+"Stato_funzione"+CHR$(34)+":"+STR$ Stato_funzione@+","
msg$=msg$ +CHR$(34)+"Pressione_in_ingresso"+CHR$(34)+":"+ STR$ Pressione_in_ingresso@ +","+CHR$(34)+"Pressione_in_uscita"+CHR$(34)+":"+ STR$ Pressione_in_uscita@ +","
msg$=msg$ +CHR$(34)+"Contabilizzatore"+CHR$(34)+":"+ STR$ Contabilizzatore@+","+CHR$(34)+"Modalita"+CHR$(34)+":"+ STR$ Modalita@+","
msg$=msg$ +CHR$(34)+"Allarme_pannello_solare"+CHR$(34)+":"+ STR$ Allarme_pannello_solare@+","
msg$=msg$ +CHR$(34)+"Allarme_batterie"+CHR$(34)+":"+ STR$ Allarme_batterie@+","+CHR$(34)+"Allarme_apertura_quadro"+CHR$(34)+":"+ STR$ Allarme_apertura_quadro@+","
msg$=msg$ +CHR$(34)+"Allarme_pressione_uscita"+CHR$(34)+":"+ STR$ Allarme_pressione_uscita@+","+CHR$(34)+"Allarme_portata_uscita_max"+CHR$(34)+":"+ STR$ Allarme_portata_uscita_max@+","
msg$=msg$ +CHR$(34)+"Allarme_portata_residua_EV_chiusa"+CHR$(34)+":"+ STR$ Allarme_portata_residua_EV_chiusa@+","
msg$=msg$ +CHR$(34)+"Portata_istantanea"+CHR$(34)+":"+ STR$ Portata_istantanea@ +","+CHR$(34)+"Stato_elettrovalvola"+CHR$(34)+":"+ STR$ Stato_elettrovalvola@+","+CHR$(34)+"Stato_selettore"+CHR$(34)+":"+ STR$ Stato_selettore@+","
msg$=msg$ +CHR$(34)+"Allarme_guasto_pressostato"+CHR$(34)+":"+ STR$ Allarme_guasto_pressostato@ +","+CHR$(34)+"Allarme_pressione_non_raggiungibile"+CHR$(34)+":"+ STR$ Allarme_pressione_non_raggiungibile@+","
msg$=msg$ +CHR$(34)+"bottone_1"+CHR$(34)+":"+ STR$ chiudi_sicur@ +","+CHR$(34)+"bottone_2"+CHR$(34)+":"+ STR$ forza_funz@+"}"
PRINT "sts: " + msg$
topicSts$="MQTT_eWON/"+"MQTT_"+idn$+"/sts"
MQTT "Publish",topicSts$,msg$,0,0
msg$=""
ENDFN
FUNCTION cloudMQTTPublishAllCmd()
  // Pubblicazione oneshot MQTT variabile Factor
  msg$=  "{"//+CHR$(34)+"Telefono_1"+CHR$(34)+":"+ CHR$(34)+ Telefono_1@ +CHR$(34)+","+CHR$(34)+"Telefono_2"+CHR$(34)+":"+ CHR$(34)+ Telefono_2@ +CHR$(34)+","+CHR$(34)+"Telefono_3"+CHR$(34)+":"+ CHR$(34)+ Telefono_3@ +CHR$(34)+","
  //msg$=msg$ +CHR$(34)+"Telefono_4"+CHR$(34)+":"+ CHR$(34)+ Telefono_4@ +CHR$(34)+","+CHR$(34)+"Telefono_5"+CHR$(34)+":"+ CHR$(34)+ Telefono_5@ +CHR$(34)+","+CHR$(34)+"Telefono_6"+CHR$(34)+":"+ CHR$(34)+ Telefono_6@ +CHR$(34)+","
  msg$=msg$ +CHR$(34)+"Isteresi_regolazione_portata"+CHR$(34)+":"+ STR$ Isteresi_regolazione_portata@ +","+CHR$(34)+"Isteresi_regolazione_pressione"+CHR$(34)+":"+ STR$ Isteresi_regolazione_pressione@ +","
  msg$=msg$ +CHR$(34)+"SP_allarme_press_ingresso_min"+CHR$(34)+":"+ STR$ SP_allarme_press_ingresso_min@ +","+CHR$(34)+"SP_allarme_press_uscita_min"+CHR$(34)+":"+ STR$ SP_allarme_press_uscita_min@ +","
  msg$=msg$ +CHR$(34)+"SP_allarme_press_uscita_max"+CHR$(34)+":"+ STR$ SP_allarme_press_uscita_max@ +","+CHR$(34)+"SP_regolazione_portata"+CHR$(34)+":"+ STR$ SP_regolazione_portata@+","
  msg$=msg$ +CHR$(34)+"SP_allarme_portata_uscita_massima"+CHR$(34)+":"+ STR$ SP_allarme_portata_uscita_massima@ +","+CHR$(34)+"SP_regolazione_pressione"+CHR$(34)+":"+ STR$ SP_regolazione_pressione@+","
  //msg$=msg$ +CHR$(34)+"Lunedi"+CHR$(34)+":"+ STR$ Lunedi@ +","+CHR$(34)+"Martedi"+CHR$(34)+":"+ STR$ Martedi@+","+CHR$(34)+"Mercoledi"+CHR$(34)+":"+ STR$ Mercoledi@ +","+CHR$(34)+"Giovedi"+CHR$(34)+":"+ STR$ Giovedi@ +","
  //msg$=msg$ +CHR$(34)+"Venerdi"+CHR$(34)+":"+ STR$ Venerdi@+","+CHR$(34)+"Sabato"+CHR$(34)+":"+ STR$ Sabato@+","+CHR$(34)+"Domenica"+CHR$(34)+":"+ STR$ Domenica@+","
  msg$=msg$ +CHR$(34)+"Reset"+CHR$(34)+":false,"+CHR$(34)+"chiudi"+CHR$(34)+":false,"+CHR$(34)+"apri"+CHR$(34)+":false,"+CHR$(34)+"chiudi_sicur"+CHR$(34)+":"+ STR$ chiudi_sicur@ +","//
  msg$=msg$ +CHR$(34)+"reset_max"+CHR$(34)+":false,"+CHR$(34)+"forza_funz"+CHR$(34)+":false}"
  PRINT "cmd: " + msg$
  topicCmd$="MQTT_eWON/"+"MQTT_"+idn$+"/cmd"
  Mqtt "Publish",topicCmd$,msg$,0,0
  msg$=""
ENDFN
Rem --- eWON user (end)
End
Rem --- eWON end section: Update MQTT
Rem --- eWON start section: Allarmi
Rem --- eWON user (start)
FUNCTION NomeEwon
alfabeto$="ABCDEFGHIJKLMNOPQRSTUVWZ"
numeroEwon$=idn$(7 TO)
numeroEwon%=VAL(numeroEwon$)
IF(numeroEwon%=1) THEN nomeEwon$="SALA POMPE"
IF(numeroEwon%=2) THEN nomeEwon$="CHERIO BASELLA"
IF(numeroEwon%>2 AND numeroEwon%<58) THEN nomeEwon$="GRUPPO " + numeroEwon$
IF(numeroEwon%=58) THEN nomeEwon$="GRUPPO 5 BIS"
IF(numeroEwon%=59) THEN nomeEwon$="GRUPPO 24 BIS"
IF(numeroEwon%=60) THEN nomeEwon$="GRUPPO 25 BIS"
IF(numeroEwon%=61) THEN nomeEwon$="GRUPPO 27 BIS"
IF(numeroEwon%=62) THEN nomeEwon$="GRUPPO 29 BIS"
IF(numeroEwon%=63) THEN nomeEwon$="GRUPPO 30 BIS"
IF(numeroEwon%=64) THEN nomeEwon$="GRUPPO 31 BIS"
IF(numeroEwon%=65) THEN nomeEwon$="GRUPPO 32 BIS"
IF(numeroEwon%>65 AND numeroEwon%<75) THEN
  n%=numeroEwon%-65
  nomeEwon$="NODO " + alfabeto$(n% TO n%) +" A1/A2"
ENDIF
IF(numeroEwon%>74 AND numeroEwon%<88) THEN
  n%=numeroEwon%-74
  nomeEwon$="NODO " + alfabeto$(n% TO n%) +" B1/B2"
ENDIF
IF(numeroEwon%>87 AND numeroEwon%<93) THEN
  n%=numeroEwon%-87
  nomeEwon$="NODO " + alfabeto$(n% TO n%) +" B3"
ENDIF
IF(numeroEwon%=93) THEN nomeEwon$="RP"
ENDFN
FUNCTION SMSAllarmi
PRINT "Invio SMS"
IF  Allarme_apertura_quadro@ = 1 OR Allarme_pressione_uscita@=1 THEN 
  IF Allarme_apertura_quadro@ = 1 THEN testoSMS$="Allarme Apertura Quadro "
  IF Allarme_pressione_uscita@=1 THEN testoSMS$="Allarme Pressione Uscita "
  FOR $i%=1 TO 6
    PRINT "Invio SMS " + "Telefono_" + STR$ $i%
    $Telefono_i$ = "Telefono_" + STR$ $i%
    Telefono$=GETIO $Telefono_i$
    SENDSMS Telefono$+",gsm,0", testoSMS$ + nomeEwon$
  NEXT $i%
ENDIF
ENDFN
Rem --- eWON user (end)
End
Rem --- eWON end section: Allarmi
Rem --- eWON start section: Invio Valori
Rem --- eWON user (start)
InvioVal:
IF (invia_val@=1) THEN
  PRINT "Invio Valori"
  @cloudMQTTPublishAllSts()
  @cloudMQTTPublishAllCmd()
ENDIF
END
Rem --- eWON user (end)
End
Rem --- eWON end section: Invio Valori
